#include "common.h"
#include "mylist.h"

int 
mylist_init(mylist** l)
{
	*l = (mylist*)malloc(sizeof(mylist));
	(*l)->first_node	= NULL;
	(*l)->curr_node	= NULL;
	(*l)->last_node	= NULL;
	return 0;
}

int 
mylist_add(mylist* l, void* d, long len)
{
	mylist_node* n = (mylist_node*)malloc(sizeof(mylist_node));
	if (!l->first_node)
	{
		l->first_node = l->last_node = l->curr_node = n;
	}
	else
	{	
		l->last_node->next = n;
		l->last_node = l->curr_node = n;
	}
	n->next 	= NULL;
	n->data_len = len;
	n->data = malloc(len);
	memcpy(n->data, d, len);
	return 0;
}

int 
mylist_free(mylist* l)
{
	mylist_node *n, *n2;
	if (!l) return -1;
	n = l->first_node;
	while (n)
	{
		free(n->data);
		n2 = n;
		n = n->next;
		free(n2);
	}
	free(l);
	return 0;
}

void*
mylist_get_first(mylist* l, long* len)
{
	if (!l)	
		return NULL;
	if (!l->first_node)	
		return NULL;
	*len = l->first_node->data_len;
	l->curr_node = l->first_node;
	return l->first_node->data;
}

void* 
mylist_get_next(mylist* l, long* len)
{
	if (!l) 
		return NULL;
	if (!l->curr_node)
		return NULL;
	if (!l->curr_node->next)
		return NULL;
	l->curr_node = l->curr_node->next;
	*len = l->curr_node->data_len;
	return l->curr_node->data;
}
